support for multiple slice reference images
[sliceimage.git] / build.sh
index 7992ebb..c5cfcb7 100755 (executable)
--- a/build.sh
+++ b/build.sh
@@ -37,42 +37,44 @@ pl_process_fedora_options $@
 shiftcount=$?
 shift $shiftcount
 
+# pldistro expected as $1 
+pldistro=$1 ; shift
+# The vserver reference name - this comes from spec's slicefamily
+vrefname=$1; shift
+
 # Do not tolerate errors
 set -e
 
 # Path's to the vserver references images and stubs
 vrefdir=$PWD/vservers/.vref
-vstubdir=$PWD/vservers/.vstub
-
-# XXX: The vserver reference name should be passed in as an argument
-# rather than being hardcoded.
-vrefname=default
+vref=${vrefdir}/${vrefname}
+# stubs are created in a subdir per slicefamily
+vstubdir=$PWD/vservers/.vstub/${vrefname}
 
 # Make /vservers and default vserver reference image
-vref=${vrefdir}/${vrefname}
 install -d -m 755 ${vref}
 
-# "Parse" out the packages and groups for mkfedora
-options=""
-vrefpackages=$(pl_getPackages base.lst)
-for package in ${vrefpackages} ; do  options="$options -p $package"; done
-vrefgroups=$(pl_getGroups base.lst)
-for group in ${vrefgroups} ; do options="$options -g $group"; done
-
-# Populate a minimal /dev in the reference image
-pl_makedevs ${vref}
+# Some of the PlanetLab RPMs attempt to (re)start themselves in %post,
+# unless the installation is running inside the BootCD environment. We
+# would like to pretend that we are.
+export PL_BOOTCD=1
 
 # Populate image with vserver-reference packages
-pl_setup_chroot ${vref} ${options}
+pl_root_makedevs ${vref}
+# locate the packages and groups file
+pkgsfile=$(pl_locateDistroFile ../build/ ${pldistro} vserver.pkgs)
+pl_root_mkfedora ${vref} ${pldistro} $pkgsfile
+pl_root_tune_image ${vref}
 
-for systemvserver in reference-vservers/*.lst ; do
-    NAME=$(basename $systemvserver .lst)
+systemvserver_count=$(ls ../build/config.${pldistro}/vserver-*.pkgs 2> /dev/null | wc -l)
+[ $systemvserver_count -gt 0 ] && for systemvserver in $(ls ../build/config.${pldistro}/vserver-*.pkgs) ; do
+    NAME=$(basename $systemvserver .pkgs | sed -e s,vserver-,,)
 
     echo "--------START BUILDING system vserver ${NAME}: $(date)"
 
     # "Parse" out the packages and groups for yum
-    systempackages=$(grep "^package:.*" $systemvserver | awk '{print $2}')
-    systemgroups=$(grep "^group:.*" $systemvserver | awk '{print $2}')
+    systempackages=$(pl_getPackages ${pl_DISTRO_NAME} $pldistro $systemvserver)
+    systemgroups=$(pl_getGroups ${pl_DISTRO_NAME} $pldistro $systemvserver)
 
     vdir=${vstubdir}/${NAME}
     rm -rf ${vdir}/*
@@ -89,12 +91,19 @@ for systemvserver in reference-vservers/*.lst ; do
     [ -n "$systempackages" ] && yum -c ${vdir}/etc/yum.conf --installroot=${vdir} -y install $systempackages
     [ -n "$systemgroups" ] && yum -c ${vdir}/etc/yum.conf --installroot=${vdir} -y groupinstall $systemgroups
 
+    pkgsdir=$(dirname $pkgsfile)
+    pkgsname=$(basename $pkgsfile .pkgs)
+    postfile="${pkgsdir}/${pkgsname}.post"
+    [ -f $postfile ] && /bin/bash $postfile ${vdir} || :
+
     # Create a copy of the system vserver w/o the vserver reference files and make it smaller. 
     # This is a three step process:
 
     # step 1: clean out yum cache to reduce space requirements
     yum -c ${vdir}/etc/yum.conf --installroot=${vdir} -y clean all
 
+    [ -f ${vdir}/etc/yum.conf.rpmnew ] && mv -f ${vdir}/etc/yum.conf.rpmnew ${vdir}/etc/yum.conf
+
     # step 2: figure out the new/changed files in ${vdir} vs. ${vref} and compute ${vdir}.changes
     rsync -anv ${vdir}/ ${vref}/ > ${vdir}.changes
     linecount=$(wc -l ${vdir}.changes | awk ' { print $1 } ')
@@ -118,4 +127,12 @@ for systemvserver in reference-vservers/*.lst ; do
     echo "--------DONE BUILDING system vserver ${NAME}: $(date)"
 done
 
+pkgsdir=$(dirname $pkgsfile)
+pkgsname=$(basename $pkgsfile .pkgs)
+postfile="${pkgsdir}/${pkgsname}.post"
+[ -f $postfile ] && /bin/bash $postfile ${vref} || :
+
+# switch the vserver reference /etc/yum.conf to the new one from the yum package
+[ -f ${vref}/etc/yum.conf.rpmnew ] && mv -f ${vref}/etc/yum.conf.rpmnew ${vref}/etc/yum.conf
+
 exit 0